"use strict";

require("core-js/modules/es.symbol");

require("core-js/modules/es.symbol.description");

require("core-js/modules/es.symbol.iterator");

require("core-js/modules/es.array.filter");

require("core-js/modules/es.array.for-each");

require("core-js/modules/es.array.includes");

require("core-js/modules/es.array.iterator");

require("core-js/modules/es.array.map");

require("core-js/modules/es.array.some");

require("core-js/modules/es.function.name");

require("core-js/modules/es.object.assign");

require("core-js/modules/es.object.define-properties");

require("core-js/modules/es.object.define-property");

require("core-js/modules/es.object.get-own-property-descriptor");

require("core-js/modules/es.object.get-own-property-descriptors");

require("core-js/modules/es.object.keys");

require("core-js/modules/es.object.to-string");

require("core-js/modules/es.string.includes");

require("core-js/modules/es.string.iterator");

require("core-js/modules/web.dom-collections.for-each");

require("core-js/modules/web.dom-collections.iterator");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

var _AppPropTypes = require("../../utils/AppPropTypes");

var _defaultProps = _interopRequireDefault(require("../../utils/defaultProps"));

var _moveHighlighted = _interopRequireDefault(require("../../utils/moveHighlighted"));

var _essentialLodash = require("../../utils/essentialLodash");

var _reactDom = _interopRequireDefault(require("react-dom"));

var _styledComponents = require("../styledComponents/styledComponents");

var _withKeys = _interopRequireDefault(require("../../utils/withKeys"));

var _callOnChange = _interopRequireDefault(require("../../utils/callOnChange"));

var _useUpdateSelection = _interopRequireDefault(require("../../hooks/useUpdateSelection/useUpdateSelection"));

var _keyCodes = require("../../utils/keyCodes");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(source, true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(source).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance"); }

function _iterableToArrayLimit(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

var targetHasValue = function targetHasValue(e) {
  return e.target.hasAttribute('value') || e.target.hasAttribute('val');
};

var targetValue = function targetValue(e) {
  return String(e.target.value || e.target.getAttribute('val') || '');
};

var Select = function Select(rawProps) {
  var props = rawProps.massaged ? rawProps : rawProps.massageDataIn(rawProps);
  var selfRef = (0, _react.useRef)(null);

  var _useState = (0, _react.useState)(false),
      _useState2 = _slicedToArray(_useState, 2),
      areOptionsOpen = _useState2[0],
      setAreOptionsOpen = _useState2[1];

  var _useState3 = (0, _react.useState)(''),
      _useState4 = _slicedToArray(_useState3, 2),
      searchText = _useState4[0],
      setSearchText = _useState4[1];

  var _useState5 = (0, _react.useState)(props.text_placeholder),
      _useState6 = _slicedToArray(_useState5, 2),
      placeholder = _useState6[0],
      setPlacholder = _useState6[1];

  var _useState7 = (0, _react.useState)(),
      _useState8 = _slicedToArray(_useState7, 2),
      optionHighlighted = _useState8[0],
      setOptionHighlighted = _useState8[1];

  var _useState9 = (0, _react.useState)(),
      _useState10 = _slicedToArray(_useState9, 2),
      selectionHighlighted = _useState10[0],
      setSelectionHighlighted = _useState10[1];

  var _useState11 = (0, _react.useState)(0),
      _useState12 = _slicedToArray(_useState11, 2),
      width = _useState12[0],
      setWidth = _useState12[1];

  (0, _react.useEffect)(function () {
    if (areOptionsOpen) setWidth(selfRef && selfRef.current ? selfRef.current.offsetWidth : 0);
  }, [areOptionsOpen]); // When options open make sure width is correct

  (0, _react.useEffect)(function () {
    setOptionHighlighted();
    setSelectionHighlighted();
  }, [searchText]); // If search text changes remove highlight

  (0, _useUpdateSelection.default)(props); // Update selection based on prop changes

  var hasOptions = !!props.options.length;
  var hasSelection = !!props.selection.length;
  var singleNoOptions = !hasOptions && !props.multiple && props.creatable;
  var filteredOptions = props.filterOptions(props, searchText);
  var showSelection = props.multiple || !areOptionsOpen; // Multiple: always show. Single: show when options are closed

  var showSearch = props.multiple || areOptionsOpen || !props.selection.length; // Multiple: always show. Single: show when options are open or when nothing is selected (placeholder should be shown)

  var styles = _objectSpread({
    styles_width: width,
    styles_multiple: props.multiple,
    styles_disabled: props.disabled,
    styles_hasSelection: hasSelection,
    styles_hasOptions: hasOptions,
    styles_optionHighlighted: optionHighlighted,
    styles_selectionHighlighted: selectionHighlighted,
    styles_rightToLeft: props.rightToLeft
  }, (0, _withKeys.default)(props, 'styles_'));

  var newWidth = selfRef && selfRef.current ? selfRef.current.offsetWidth : 0;
  if (width !== newWidth) setWidth(newWidth); // Make sure width is updated correctly

  if (!hasOptions && !props.creatable) {
    console.error('Select has no options and is not creatable, nothing to display. Consider adding options or making it creatable');
  }

  if (props.creatable && searchText && !filteredOptions.some(function (option) {
    return option.value === searchText;
  }) && (props.allowDuplicates || !props.selection.some(function (item) {
    return item.value === searchText;
  }))) // Don't allow duplicates
    {
      filteredOptions.push({
        value: searchText,
        label: props.text_create + " \"".concat(searchText, "\"")
      }); // Add option for creatable
    }

  if (selectionHighlighted == null && !filteredOptions.map(function (option) {
    return option.value;
  }).filter(function (value) {
    return value != null;
  }).includes(optionHighlighted)) {
    var newOptionHighlighted = (0, _moveHighlighted.default)(filteredOptions, 1, optionHighlighted);
    if (newOptionHighlighted !== optionHighlighted) setOptionHighlighted(newOptionHighlighted);
  }

  var newPlaceholder = areOptionsOpen && !props.multiple && props.selection.length ? props.selection[0].label // Set placeholder to current selection on single select
  : props.text_placeholder;
  if (!singleNoOptions && newPlaceholder !== placeholder) setPlacholder(newPlaceholder);
  if (singleNoOptions && !areOptionsOpen && props.selection.length && searchText === '') setSearchText(props.selection[0].label); // On single creatable with no options, edit the currently selected label
  // Events

  var onFocus = function onFocus(e) {
    setAreOptionsOpen(true);
    props.onFocus(e);
  };

  var onBlur = function onBlur(e) {
    if (singleNoOptions) {
      (0, _callOnChange.default)(props, targetValue(e)); // Make single no options behave like text input
    }

    setAreOptionsOpen(false);
    setSearchText('');
    setSelectionHighlighted();
    props.onBlur(e);
  };

  var onOptionClick = function onOptionClick(e) {
    e.preventDefault();
    if (!targetHasValue(e)) return; // no value, do nothing

    if (!props.multiple) {
      document.activeElement.blur(); // Close options on single select
    }

    (0, _callOnChange.default)(props, targetValue(e));
  };

  var onRemove = function onRemove(e) {
    if (props.removable && e.target.classList.contains('remove')) {
      (0, _callOnChange.default)(props, targetValue(e), false);
      setSearchText('');
    }
  };

  var onHoverOption = function onHoverOption(e) {
    var value = targetValue(e);

    if (value && value !== optionHighlighted) {
      setOptionHighlighted(value);
      setSelectionHighlighted();
    }
  };

  var onHoverSelection = function onHoverSelection(e) {
    if (!e.target.classList.contains('remove')) return;
    var value = targetValue(e);

    if (value && value !== optionHighlighted) {
      setOptionHighlighted();
      setSelectionHighlighted(value);
    }
  };

  var onSelectionOut = function onSelectionOut(e) {
    if (!areOptionsOpen) setSelectionHighlighted(); // Stop highlighting selection if mouse leaves select area
  };

  var onKeyDown = function onKeyDown(e) {
    var openKeys = [_keyCodes.ENTER_KEY, _keyCodes.ARROW_UP, _keyCodes.ARROW_DOWN, _keyCodes.ARROW_LEFT, _keyCodes.ARROW_RIGHT, _keyCodes.SPACE, _keyCodes.SEMI_COLON, _keyCodes.EQUAL_SIGN, _keyCodes.COMMA, _keyCodes.DASH, _keyCodes.PERIOD, _keyCodes.FORWARD_SLASH, _keyCodes.OPEN_BRACKET, _keyCodes.BACK_SLASH, _keyCodes.CLOSE_BRAKET, _keyCodes.SINGLE_QUOTE];
    if (!areOptionsOpen && ((0, _essentialLodash.inRange)(e.keyCode, _keyCodes.NUM_LETTER_START, _keyCodes.NUM_LETTER_END) || openKeys.includes(e.keyCode))) setAreOptionsOpen(true); // if you type letters, numbers, or openKeys then open options

    switch (e.keyCode) {
      case _keyCodes.TAB:
      case _keyCodes.ENTER_KEY:
        if (areOptionsOpen && optionHighlighted != null) {
          onOptionClick({
            target: {
              value: optionHighlighted,
              hasAttribute: function hasAttribute() {
                return true;
              }
            },
            preventDefault: e.preventDefault
          });
          setOptionHighlighted((0, _moveHighlighted.default)(filteredOptions, 1, optionHighlighted)); // Highlight next option

          setSelectionHighlighted();
          setSearchText('');
          if (!props.multiple) e.target.blur(); // Close options on single select
        }

        break;

      case _keyCodes.ARROW_UP:
        if (areOptionsOpen && filteredOptions.length) {
          setOptionHighlighted((0, _moveHighlighted.default)(filteredOptions, -1, optionHighlighted));
          setSelectionHighlighted();
        }

        break;

      case _keyCodes.ARROW_DOWN:
        if (areOptionsOpen && filteredOptions.length) {
          setOptionHighlighted((0, _moveHighlighted.default)(filteredOptions, 1, optionHighlighted));
          setSelectionHighlighted();
        }

        break;

      case _keyCodes.ARROW_LEFT:
        if (props.selection.length && searchText === '') {
          setSelectionHighlighted((0, _moveHighlighted.default)(props.selection, -1, selectionHighlighted, true));
          setOptionHighlighted();
        }

        break;

      case _keyCodes.ARROW_RIGHT:
        if (props.selection.length && searchText === '') {
          setSelectionHighlighted((0, _moveHighlighted.default)(props.selection, 1, selectionHighlighted, true));
          setOptionHighlighted();
        }

        break;

      case _keyCodes.ESCAPE:
        if (areOptionsOpen) setAreOptionsOpen(false);
        setSearchText('');
        setOptionHighlighted();
        setSelectionHighlighted();
        break;

      case _keyCodes.BACKSPACE:
      case _keyCodes.DELETE:
        if (!searchText && props.selection.length) {
          // Only remove if there isn't search text
          var input = document.createElement("input");
          input.value = (0, _essentialLodash.last)(props.selection).value;
          input.classList.add('remove');

          if (selectionHighlighted != null) {
            input.value = selectionHighlighted;
            setSelectionHighlighted((0, _moveHighlighted.default)(props.selection, -1, selectionHighlighted, true));
            setOptionHighlighted();
          }

          onRemove({
            target: input,
            preventDefault: e.preventDefault
          });
        }

        break;

      default:
        break;
    }
  };

  if (props.disabled) {
    onFocus = onBlur = onOptionClick = onKeyDown = onRemove = onHoverOption = function onHoverOption() {};
  }

  var HtmlFieldData = props.component_HtmlFieldData,
      Wrapper = props.component_Wrapper,
      Selection = props.component_Selection,
      SelectionList = props.component_SelectionList,
      OptionList = props.component_OptionList,
      Option = props.component_Option,
      Search = props.component_Search,
      SelectionWrapper = props.component_SelectionWrapper,
      OptionsWrapper = props.component_OptionsWrapper,
      AppendToBodyOptionsWrapper = props.component_AppendToBodyOptionsWrapper,
      StyledAppendToBodyOptionsWrapper = props.component_StyledAppendToBodyOptionsWrapper;

  var optionList = _react.default.createElement(OptionList, _extends({
    itemList: filteredOptions,
    onClick: onOptionClick,
    onMouseOver: onHoverOption,
    Item: Option,
    noItemsText: hasOptions ? props.text_noOptions : props.text_create + '...'
  }, styles));

  return (hasOptions || props.creatable) && _react.default.createElement(Wrapper, _extends({}, styles, {
    ref: selfRef
  }), _react.default.createElement(HtmlFieldData, {
    name: props.name,
    itemList: props.selection
  }), _react.default.createElement(SelectionWrapper, _extends({
    onFocus: onFocus,
    onBlur: onBlur,
    svg_Expand: props.svg_Expand
  }, styles, {
    areOptionsOpen: areOptionsOpen,
    SelectionList: showSelection && _react.default.createElement(SelectionList, _extends({
      itemList: props.selection,
      onClick: onRemove,
      onMouseOver: onHoverSelection,
      onMouseOut: onSelectionOut,
      removable: !props.disabled && props.removable,
      svg_Remove: props.svg_Remove,
      Item: Selection
    }, styles)),
    Search: _react.default.createElement(Search, _extends({
      hide: !showSearch,
      placeholder: placeholder,
      searchText: searchText,
      onKeyDown: onKeyDown,
      onChange: function onChange(e) {
        return setSearchText(targetValue(e));
      }
    }, styles))
  })), !props.appendToBody && areOptionsOpen && _react.default.createElement(_styledComponents.DivRelative, null, _react.default.createElement(OptionsWrapper, styles, optionList)), props.appendToBody && areOptionsOpen && _reactDom.default.createPortal(_react.default.createElement(AppendToBodyOptionsWrapper, _extends({}, styles, {
    parentRef: selfRef,
    filteredOptions: filteredOptions,
    StyledAppendToBodyOptionsWrapper: StyledAppendToBodyOptionsWrapper,
    updateOn: [props.selection]
  }), optionList), document.body));
};

Select.defaultProps = _defaultProps.default;
Select.propTypes = _AppPropTypes.simpleNewInputPropTypes;
var _default = Select;
exports.default = _default;