"use strict";

require("core-js/modules/es.array.filter");

require("core-js/modules/es.array.find");

require("core-js/modules/es.array.index-of");

require("core-js/modules/es.array.map");

require("core-js/modules/es.array.splice");

require("core-js/modules/es.function.name");

require("core-js/modules/es.object.define-property");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var internalCallOnChange = function internalCallOnChange(props, value) {
  props.onChange({
    target: {
      value: props.massageDataOut(props, value),
      name: props.name
    }
  });
};

var callOnChange = function callOnChange(props, newValue) {
  var add = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : true;
  var replace = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : false;

  if (Array.isArray(newValue) && !newValue.length) {
    internalCallOnChange(props, newValue); // Empty

    return;
  }

  var value = add ? [newValue] : [];
  var newOption = props.options.find(function (option) {
    return option.value === newValue;
  });

  if (props.multiple && !replace) {
    value = props.selection.map(function (option) {
      return option.value;
    });

    if (add) {
      if (newOption.parent) {
        // Option is a parent, remove selected children
        value = props.selection.filter(function (option) {
          return option.group !== newOption.group;
        }).map(function (option) {
          return option.value;
        });
      }

      value.push(String(newValue)); // Add
    } else {
      value.splice(value.indexOf(String(newValue)), 1); // Remove
    }
  }

  internalCallOnChange(props, value);
};

var _default = callOnChange;
exports.default = _default;